do
	--Stole from LibReforge
	local SPI = 1
	local DODGE = 2
	local PARRY = 3
	local HIT = 4
	local CRIT = 5
	local HASTE = 6
	local EXP = 7
	local MASTERY = 8
	
	local StatToID = {
	["Spirit"] = SPI,
	["DodgeRating"] = DODGE,
	["ParryRating"] = PARRY,
	["HitRating"] = HIT,
	["CritRating"] = CRIT,
	["HasteRating"] = HASTE,
	["ExpertiseRating"] = EXP,
	["MasteryRating"] = MASTERY,
	}
	
	local function WowReforge(inputString)
		local slotNames = {
		["Head"] = 1,
		["Neck"] = 2,
		["Shoulders"] = 3,
		["Chest"] = 5,
		["Waist"] = 6,
		["Legs"] = 7,
		["Feet"] = 8,
		["Wrists"] = 9,
		["Hands"] = 10,
		["Ring1"] = 11,
		["Ring2"] = 12,
		["Trinket1"] = 13,
		["Trinket2"] = 14,
		["Back"] = 15,
		["WeaponMainHand"] = 16,
		["WeaponOffHand"] = 17,
		["Range"] = 18,
		}
		
		local reforgeTable = {}
		local reforgeString = inputString .. "\n"
		local numReforges = 0
		for w in string.gmatch(reforgeString, "(.-)\n") do
			local itemName = nil
			local first, last, slot, from, to = string.find(w, "([%a%d]*)%s*:*%s*(%a*)%s*%->%s*(%a*)")
			if (slotNames[slot] and slotNames[slot] ~= "Used") then
				itemName = select(1,GetItemInfo(GetInventoryItemID("player", slotNames[slot])))
				slotNames[slot] = "Used"
			end
			if (from and to and itemName) then
--~ 				Reforgerade:DebugPrint("Reforge -" .. itemName .. "- from -" .. from .. "- to -" .. to .. "-")
				reforgeTable[itemName] = {StatToID[from], StatToID[to]}
				numReforges = numReforges + 1
			else
--~ 				Reforgerade:DebugPrint("unable to parse line " .. w)
--~ 				print(from, to, itemName, slot)
			end
		end
		if numReforges > 0 then
			for k,v in pairs(slotNames) do
				if (v ~= "Used") then
					local itemName = select(1,GetItemInfo(GetInventoryItemID("player", v)))
					reforgeTable[itemName] = {0,0}
	--~ 				Reforgerade:DebugPrint("Reforge " .. itemName .. " from none to none")
					slotNames[k] = "Used"
				end
			end
		end
		return reforgeTable
	end
		
	Reforgerade:RegisterParser("WowReforge", WowReforge)
end